# botoplus

Cloud Security Posture Management (CSPM) is a crowded market space with all the commercial and open-source offerings. Why do we need yet another set of Python Boto3 scripts? 

Having written so much code over the years, it was time for a more extensible framework addressing common pitfalls while maintaining flexibility for AWS Security Operations. 

**Common Pitfalls**

- [x] Identity Access Management (SSO)
- [x] User Interface (Jupyter Notebooks)

### Getting Started

| Notebook | Description |
| -------- | ----------- |
| [Authentication](authentication.ipynb) | GitHub Codespaces: AWS CLIv2 and Python Library Configuration |

### Organizations

| Notebook | Description |
| -------- | ----------- |
| [Identify Privileged Accounts](organizations/identify-privileged-accounts.ipynb) | List of Delegated Administration Accounts & Services |

### Security Hub

| Notebook | Description |
| -------- | ----------- |
| [Minimal Cost Configuration](securityhub/minimal-cost-configuration.ipynb) | Disable All Standards & Limit Subscriptions (IAM Analyzer & Health) |
